SealBar = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0")
SealBar:RegisterChatCommand("/SealBar", "/sb", nil)

function SealBar:OnEnable()
    self:RegisterEvent("SPELL_UPDATE_COOLDOWN")
    self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function SealBar:PLAYER_ENTERING_WORLD()
    if SealBarClassCheck() then
        SealBarLoad()
    end
end

function SealBarLoad()
    if getglobal(SealBarButton1) then return end
    local width, height, scale = 60, 60, .636
    local SealBarLastButton = "MultiBarBottomRightButton12"
    
    SealBarButton1 = CreateFrame("Button", "SealBarButton1", UIParent, "SealBarButtonTemplate")
    SealBarButton2 = CreateFrame("Button", "SealBarButton2", UIParent, "SealBarButtonTemplate")
    SealBarButton3 = CreateFrame("Button", "SealBarButton3", UIParent, "SealBarButtonTemplate")
    SealBarButton4 = CreateFrame("Button", "SealBarButton4", UIParent, "SealBarButtonTemplate")
    SealBarButton5 = CreateFrame("Button", "SealBarButton5", UIParent, "SealBarButtonTemplate")
    SealBarButton6 = CreateFrame("Button", "SealBarButton6", UIParent, "SealBarButtonTemplate")
    SealBarButton7 = CreateFrame("Button", "SealBarButton7", UIParent, "SealBarButtonTemplate")
    SealBarButton8 = CreateFrame("Button", "SealBarButton8", UIParent, "SealBarButtonTemplate")
    SealBarButton9 = CreateFrame("Button", "SealBarButton9", UIParent, "SealBarButtonTemplate")
    SealBarButton10 = CreateFrame("Button", "SealBarButton10", UIParent, "SealBarButtonTemplate")
    SealBarButton11 = CreateFrame("Button", "SealBarButton11", UIParent, "SealBarButtonTemplate")
    SealBarButton12 = CreateFrame("Button", "SealBarButton12", UIParent, "SealBarButtonTemplate")

    for i = 1, countEntries(SealBarSpells) do
        if IsUsableSpell(SealBarSpells[i]) then
            local button = getglobal("SealBarButton"..i)
            button:SetWidth(width); button:SetHeight(height); button:SetScale(scale); button:EnableMouse(true)
            
            if (i == 1) then
                button:SetPoint("CENTER", MultiBarBottomRightButton12, "TOP", 0, 36)
            elseif (SealBarLastButton == "MultiBarBottomRightButton12") then
                button:SetPoint("CENTER", MultiBarBottomRightButton12, "TOP", 0, 36)
            else
                button:SetPoint("CENTER", SealBarLastButton, "LEFT", -36, 0)
            end
            
            button:SetAttribute("type", "spell")
            button:SetAttribute("spell", SealBarSpells[i])

            button:SetScript("OnLeave", function() GameTooltip:Hide() end)
            button:SetScript("OnEnter", function()
                GameTooltip:SetOwner(this, "ANCHOR_CURSOR")
                GameTooltip:SetSpell(SealBar_GetSpellID(SealBarSpells[i]))
                GameTooltip:Show()
            end)

            local t = button:CreateTexture(nil,"BACKGROUND")
                t:SetTexture(GetSpellTexture(SealBarSpells[i]))
                t:SetAllPoints(button)
                button.texture = t
            
            SealBarLastButton = button
        end
    end
end

-- UPDATE COOLDOWN
function SealBar:SPELL_UPDATE_COOLDOWN()
    if SealBarClassCheck() then
        for i = 1, countEntries(SealBarSpells) do
            if (GetSpellCooldown(SealBarSpells[i]) ~= nil and GetSpellCooldown(SealBarSpells[i]) > 0) then
                local start, duration, enable = GetSpellCooldown(SealBarSpells[i])
                getglobal("SealBarButton".. i .."Cooldown"):SetCooldown(start, duration)
            end
        end
    end
end

-- RETURN CLASS
function SealBarClassCheck()
    local _, class = UnitClass("player")
    if class == "PALADIN" then return true else return false end
end

-- FIND HIGHEST SPELL RANK
function SealBar_GetSpellID(spell, rank)
	local i = 1
	local spellID
	local highestRank
	while true do
		local spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL)
		if (not spellName) then
			break
		end
		if (spellName == spell) then
			if (rank) then
				if (spellRank == rank) then
					return i
				end
			else
				spellID = i
				highestRank = spellRank
			end
		end
		i = i + 1
		if (i > 250) then
			break
		end
	end			
	return spellID, highestRank
end

-- COUNT TOTAL ENTRIES IN A TABLE
function countEntries(tbl)
    local cnt = 0;
    for k in pairs(tbl) do cnt = cnt + 1; end
    return cnt
end